macroScript HALO_Toolbar
	category:"HALO Tools"
	tooltip:"HALO Toolbar"
	Icon:#("HALO_Tools",1)
	
(


-- HALO Toolbar Copyright 2005  Matt Regan  All Rights Reserved.
--
-- Version 1.00 Matt Regan 4-11-05 
--		First rev.


-- define date and build
HTversion = "1.0"
HTdate = "4-13-2005"
IconNo = 3 -- just to be lazy ; )

-- define bitmaps
HTBbmi = ("$ui\icons\Halo_tools_24i.bmp")
HTBbmm = ("$ui\icons\Halo_tools_24m.bmp")
HTBbml = ("$ui\icons\Halo_Toolbar_Logo.bmp")

-- ----------Rollouts---------- --
rollout ro_main "Tools" (
	----------
	group "Prep Tool"
	(
	button b_HMPT "HMPT"  width:32 height:32 tooltip:"Prep tool (Run first)"\
		images:#(HTBbmi,HTBbmm,IconNo,2,2,2,2) 
	checkbox cb_fNormals "Flip Normals" checked:true width:128
	checkbox cb_weld "Weld Vertices" checked:true width:128
	checkbox cb_smooth "Smooth" checked:true width:128
	checkbox cb_scale "Scale" checked:true width:128
	radioButtons rb_output "Output:" labels:#("Polly", "Mesh", "None") width:128 default:1 columns:3

	)
	----------
	group "UVW Tool"
	(
	button b_UVWT "UVWT"  width:30 height:30 tooltip:\
		"UVW tool (Run second, **each object must be selected individually**)"\
		 images:#(HTBbmi,HTBbmm,IconNo,3,3,3,3)
	button b_sel "Selection Floater" tooltip:"Use for easy selecting"
	)
	----------
	-- ---------- Functions ---------- --
	on b_HMPT pressed do (
		undo "HMPT" on (
			actionMan.executeAction 0 "40021"  -- Edit: Select All
			max select all
		
			if (cb_fNormals.checked == true) do  --add normal mod
				(
				modPanel.addModToSelection (Normalmodifier ()) ui:on
				$object_0.modifiers[#Normal].flip = on 
				)
			
				if (cb_weld.checked == true) do -- add weld mod
				(
				modPanel.addModToSelection (Vertex_Weld ()) ui:on
				$object_0.modifiers[#Vertex_Weld].threshold = 0.1
				)
		
				if (cb_smooth.checked == true) do  --add smooth mod
				(
				modPanel.addModToSelection (smooth ()) ui:on 
				$object_0.modifiers[#Smooth].autosmooth = on
				$object_0.modifiers[#Smooth].threshold = 50
				)
				
			if (cb_scale.checked == true) do 
				(
				scale $ [0.1,0.1,0.1]
				)
	
			if (rb_output.state == 1) do 
				(
				macros.run "Modifier Stack" "Convert_to_Poly"
				)
		
			if (rb_output.state == 2) do 
				(
				macros.run "Modifier Stack" "Convert_to_Mesh"
				)
	
			max tool zoomextents all
		)--end of undo
	)-- end of b_UVWT
	----------
	
	on b_UVWT pressed do (
		undo "UVWT" on (
			
			modPanel.addModToSelection (Unwrap_UVW ()) ui:on
			
			numvert = $.unwrap_uvw.unwrap.NumberVertices() 	-- Define Num vert
			currentvert = 1 	-- Define Current vert
			
			vertpos = [0,0,0]	-- Define vertpos
			
			while currentvert <= numvert do
				(
				vertpos = $.unwrap_uvw.unwrap.getvertexposition 0 currentvert -- get currentvert pos
				if vertpos[1] < 0.0 do (
				$.unwrap_uvw.unwrap.selectvertices #{currentvert}
				$.unwrap_uvw.unwrap.moveselectedvertices [1,0,0]
				)						-- Move bad left verts over
			
				if vertpos[2]  > 1.0 do (
					$.unwrap_uvw.unwrap.selectvertices #{currentvert}
					$.unwrap_uvw.unwrap.moveselectedvertices [0,-1,0]
					)						-- Move bad upper verts down
				currentvert += 1  -- add one to current vert and restart loop
				)-- end of loop
		)-- end of undo 
	) -- end of b_UVWT
	
	----------
	
	on b_sel pressed do (
		actionMan.executeAction 0 "40266"  -- Edit: Selection Floater
		max selection floater
		) -- end of b_sel
						
) -- end of ro_main




rollout ro_About "About" (
	button b_About "About" offset:[0,0] width:128 toolTip:"About"
	button b_Help "Help" offset:[0,0] width:128 toolTip:"Help"
	----------
	rollout ro_AboutW "About"(
		bitmap bm_about "about bitmap" filename: HTBbml
		label abt_lbl1 "HALO Toolbar" 
		label abt_lbl2 "Version:"align:#left across:2;
		label abt_lbl3 "Built:"align:#right
		label abt_lbl4 ""
		label abt_lbl5 "Made by Matt Regan"align:#left across:2;
		label abt_lbl6 "Mattr@regandesigns.com"align:#right
		label abt_lbl7 ""
		label abt_lbl8 "Copyright 2005  Matt Regan.  All Rights Reserved."
		
		on ro_aboutW open do(
			abt_lbl2.text = ("Version "+HTversion);
			abt_lbl3.text = ("Built: "+HTdate);
			)		
	)-- end of aboutW
	
	----------
	
	rollout ro_help "Help" (
		label hlp_lbl1 "Help:"
		label hlp_lbl2 ""
		label hlp_lbl3 "Operation:" align:#left
		label hlp_lbl4 "" align:#left
		label hlp_lbl5 "Step one: Import all of the OBJ files for your model (Torso, legs ect.)" align:#left
		label hlp_lbl6 "Step two: Open toolbar and under the 'prep tool' group, confirm settings, and press the prep tool button." align:#left
		label hlp_lbl7 "Step three: Select an object, and press the UVW tool button under the 'UVW tool' group" align:#left
		label hlp_lbl8 "Apply texture maps, pose and render!" align:#left
		label hlp_lbl9 ""
		label hlp_lbl10 "General:" align:#left
		label hlp_lbl11 ""
		label hlp_lbl12 "The 'Output' option is used for setting the object's final type. 'Polly' is used to collapse to" align:#left
		label hlp_lbl13	"Editable polly, 'Mesh' is used for editable mesh, and 'None' will leave the stack intact, for editing." align:#left
		label hlp_lbl14 ""
		label hlp_lbl15 "The 'Selection Floater' button will bring up the Selection floater. It can be used to easily select each" align:#left
		label hlp_lbl16 "object before pressing the UVW tool button." align:#left
		label hlp_lbl17 ""
		label hlp_lbl18 "Notes:" align:#left
		label hlp_lbl19 "You must select each object individually, before pressing the UVW tool, otherwise it will not work!" align:#left
		label hlp_lbl20 ""
		label hlp_lbl21 "One of the objects MUST be named 'object_0' for the prep tool to work. If you do not want to rename any" align:#left
		label hlp_lbl22 "objects you may create a box at 0,0,0 and name it 'object_0', this may be fixed in a later version." align:#left
		label hlp_lbl23 "However, object_0, _1, _2, ect. is the default object name structure for HMT." align:#left
		label hlp_lbl24 ""
		label hlp_lbl25 "If you discover any errors or bugs, or have suggestions, feel free to Email me." align:#left
		label hlp_lbl26 "(mattr@regandesigns.com) I am always looking to improve my work!"  align:#left
		) -- end of ro_help
	
	
	-- ---------- Functions ---------- --
	
	on b_about pressed do (
		ro_aboutfloater = (newRolloutFloater ("About") 542 420)
		addRollout ro_aboutW ro_aboutfloater 
		) -- end of about
	
	on b_help pressed do (
		ro_helpfloater = (newRolloutFloater ("Help") 512 256)
		addRollout ro_help ro_helpfloater
		) -- end of help

) -- end of ro_about

-- ---------- make floater ---------- --
ro_HTfloater = (newRolloutFloater ("HALO Tools") 200 330)
addRollout ro_main ro_HTfloater
addRollout ro_about ro_HTfloater rolledUp:true
) -- End of script
